
Most APIs from tidyverse packages ignore/reset the index (row names) of data frames, so do the APIs from `datar`. So when selecting rows, row indices are always used. With most APIs, the indices of the data frames are dropped, so they are actually ranging from 0 to `nrow(df) - 1`.

!!! Note

    when using 1-based indexing (default), 1 selects the first row. Even though the first row shows index 0 when it's printed.

No `MultiIndex` indices/column names are supported for the APIs to select or manipulate data frames and the data frames generated by the APIs will not have `MultiIndex` indices/column names. However, since it's still pandas DataFrame, you can always do it in pandas way:

```python
df = tibble(x=1, y=2)
df2 = df >> mutate(z=f.x+f.y)
# pandas way to select
df2.iloc[0, z] # 3
# add multiindex to it:
df.columns = pd.MultiIndex.from_product([df.columns, ['C']])
```